/***
 * Fragment z książki „Pragmatyczny programista. Wydanie jubileuszowe”,
 * wydanej w tłumaczeniu przez Wydawnictwo Helion.
 * Ten kod jest chroniony prawem autorskim. Nie może być używany do tworzenia materiałów szkoleniowych,
 * kursów, książek, artykułów, itp. W przypadku wątpliwości, skontaktuj się z nami.
 * Nie dajemy gwarancji, że ten kod będzie przydatny do jakiegokolwiek celu.
 * Więcej informacji na temat książki znajdziesz pod adresem  http://www.pragmaticprogrammer.com/titles/tpp20.
***/
/**
  * Z podrozdziału „Jak zrównoważyć zasoby”. Pokazuje lepszy sposób równoważenia zasobów
  */

#include <stdio.h>

typedef struct {
  double balance;
} Customer;


void readCustomer(FILE *cFile, Customer *cRec) {
  fread(cRec, sizeof(*cRec), 1, cFile);
}

void writeCustomer(FILE *cFile, Customer *cRec) {
  rewind(cFile);
  fwrite(cRec, sizeof(*cRec), 1, cFile);
}

void updateCustomer(const char *fName, double newBalance) {
  FILE *cFile;
  Customer cRec;
  
  cFile = fopen(fName, "r+");        // >---
  readCustomer(cFile, &cRec);        //     |
  if (newBalance >= 0.0) {           //     |
    cRec.balance = newBalance;       //     |
    writeCustomer(cFile, &cRec);     //     |
  }                                  //     |
  fclose(cFile);                     // <---
}

int main(int argc, char **argv) {

  if (argc > 1) {
    updateCustomer(argv[1], -1.0);
    updateCustomer(argv[1], 0.0);
    updateCustomer(argv[1], 1.0);
  }
  else
    fprintf(stderr, "Brakująca nazwa pliku\n");

  return 0;
}
